
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>

#define FLN 1000

int main(int argc, char *argv[])
{
	char filename[FLN];
	float start1,end1,start2,end2;
	int bin1,bin2;
	FILE *fip;

	if(argc!=8)
	{
		printf("How to use it:\n  %s input-file start1 end1 bin1 star2 end2 bin2\n\n",argv[0]);
		exit(-1);
	}
	sprintf(filename,"%s",argv[1]);
	if((fip=fopen(filename,"r"))==NULL)
	{
		printf("Error: Can not find the input-file\n");
		exit(-1);
	}
	start1 = atof(argv[2]);
	end1 = atof(argv[3]);
	bin1 = atoi(argv[4]);
	start2 = atof(argv[5]);
	end2 = atof(argv[6]);
	bin2 = atoi(argv[7]);

	printf("Get statistics for file %s\n with first identity %f %f %d\n and second identity %f %f %d\n\n",argv[1],start1,end1,bin1,start2,end2,bin2);

	FILE *fop;
	int **Obsnum;
	int i,j,line,id1,id2;
	float value1,value2;
	char buff[FLN];

	fop=fopen("result","w");

	Obsnum = (int **)malloc((bin1+1)*sizeof(int *));
	for(i=0;i<=bin1;i++)
		Obsnum[i]=(int *)calloc(bin2+1,sizeof(int));

	line=0;
	while(fscanf(fip,"%f %f",&value1,&value2)!=EOF)
	{
		if(fgets(buff,sizeof(buff),fip)==NULL)
			break;

		line++;
		id1 = (int) ((value1 - start1)/((end1 - start1)/bin1)+0.5);
		if(id1<0)
			id1=0;
		else if(id1>bin1)
			id1=bin1;
		id2 = (int) ((value2 - start2)/((end2 - start2)/bin2)+0.5);
		if(id2<0)
			id2=0;
		else if(id2>bin2)
			id2=bin2;
		
		Obsnum[id1][id2] += 1;
	}

	printf("Print the output\n\n");
	printf("Total lines %d\n\n",line);
	for(i=0;i<=bin1;i++)
	{
		for(j=0;j<=bin2;j++)
			fprintf(fop,"%f %f %d\n",start1+i*(end1-start1)/bin1,start2+j*(end2-start2)/bin2,Obsnum[i][j]);
		fprintf(fop,"\n");
	}
	fprintf(fop,"\n");

	for(i=0;i<=bin1;i++)
	{
		id1=0;
		for(j=0;j<=bin2;j++)
			id1 += Obsnum[i][j];

		printf("%f %d\n",start1+i*(end1-start1)/bin1,id1);
	}
	printf("\n");

	for(j=0;j<=bin2;j++)
	{
		id2=0;
		for(i=0;i<=bin1;i++)
			id2 += Obsnum[i][j];

		printf("%f %d\n",start2+j*(end2-start2)/bin2,id2);
	}
	printf("\n");


	fclose(fip);
	fclose(fop);
	return(0);

}


